//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TcpScannerUnit.h"
#include "connect_thread.h"
#include "IpEdit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmTcpScanner *frmTcpScanner;
//---------------------------------------------------------------------------
__fastcall TfrmTcpScanner::TfrmTcpScanner(TComponent* Owner)
	: TForm(Owner)
{
	iActiveThreads = 0;

	edIpStart = new TIPAddress ( this );
	edIpStart->Parent = Panel1;
	edIpStart->SetBounds ( 161, 5, 118, 21 ); // dimensions
	edIpStart->TabStop = true;
	edIpStart->TabOrder = 1;
	edIpStart->IP = "192.168.1.1";

	edIpStop = new TIPAddress ( this );
	edIpStop->Parent = Panel1;
	edIpStop->SetBounds ( 161, 31, 118, 21 ); // dimensions
	edIpStop->TabStop = true;
	edIpStop->TabOrder = 1;
	edIpStop->IP = "192.168.1.254";
}

__fastcall TfrmTcpScanner::~TfrmTcpScanner()
{
	delete edIpStart;
	delete edIpStop;
}

//---------------------------------------------------------------------------
void __fastcall TfrmTcpScanner::btnStartClick(TObject *Sender)
{
	lvFound->Clear();
	iCurrentIP = 0;
	tmrNewConnect->Enabled = true;
	adrStop = TIPAddress::StringToIP( edIpStop->IP );
	iConnectionTimeoutUs = StrToIntDef(edConnectionTimeout->Text, 400) * 1000;
}
//---------------------------------------------------------------------------
void __fastcall TfrmTcpScanner::tmrNewConnectTimer(TObject *Sender)
{
	if(this->iActiveThreads >= MAX_THREADS)
		return;
	unsigned long adr = TIPAddress::StringToIP( edIpStart->IP ) + iCurrentIP;
	AnsiString scanAddress = TIPAddress::IPToString(adr);
	TConnectThread *ct =
		new TConnectThread(scanAddress, edPort->Text, iConnectionTimeoutUs, false);	//run after create
	if(ct)
	{
		this->iActiveThreads++;
		if(adr < adrStop)
			iCurrentIP++;
		else
			tmrNewConnect->Enabled = false;
		StatusBar1->Panels->Items[0]->Text = scanAddress + "...";
		StatusBar1->Panels->Items[1]->Text = "Threads: " + IntToStr(iActiveThreads);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmTcpScanner::ConnectThreadTerminated()
{
	frmTcpScanner->iActiveThreads--;
}
